PART_NAME=image
USE_REFRESH=1

platform_check_image() {
	[ "$ARGC" -gt 1 ] && return 1

	case "$(get_magic_word "$1")" in
		6873) return 0;;
		# U-Boot image files
		2705) return 0;;
		*)
			echo "Invalid image type. Please use only U-Boot image files"
			return 1
		;;
	esac
}

platform_do_upgrade() {
	if [ "$(get_magic_word "$1")" = 6873 ]; then
		PART_NAME=rootfs
	else
		PART_NAME=image
	fi
	if [ "$SAVE_CONFIG" -eq 1 -a -z "$USE_REFRESH" ]; then
		get_image "$1" | mtd -j "$CONF_TAR" write - "${PART_NAME:-image}"
	else
		get_image "$1" | mtd write - "${PART_NAME:-image}"
	fi
	sync
}

stop_services() {
	SERVICES="miniupnpd"
	for app in $SERVICES; do
		if [ -f /var/run/$app.pid ]; then
			/etc/init.d/$app stop
		fi
	done
}
append sysupgrade_pre_upgrade stop_services

