#!/bin/sh
append DRIVERS "rt3352"

prepare_config() {
        local device=$1
        config_get channel $device channel

        config_get ssid1 private ssid
        config_get mode private mode
        config_get beacon private beacon
        config_get dtim private dtim
        config_get hidessid private hidessid
        config_get autochannel private autochannel
        config_get txburst private txburst
        config_get rtsthr private rtsthr
        config_get fragthr private fragthr
        config_get maxuser private maxuser
        config_get txpower private txpower

        config_get encryption private encryption
        config_get key private key
        config_get wpa_crypto private wpa_crypto

	    config_get apcli $device apcli
	    config_get apcli_ssid $device apcli_ssid
	    config_get apcli_bssid $device apcli_bssid
	    config_get apcli_auth $device apcli_auth
	    config_get apcli_enc $device apcli_enc
	    config_get apcli_key $device apcli_key

        cat > /tmp/RT2860AP.dat<<EOF
#The word of "Default" must not be removed
Default
CountryRegion=
CountryRegionABand=
CountryCode=KR
BssidNum=1
SSID1=${ssid1:-RT3352_AP}
SSID2=
SSID3=
SSID4=
SSID5=
SSID6=
SSID7=
SSID8=
WirelessMode=${mode:-9}
FixedTxMode=
TxRate=0
Channel=${channel:-1}
BasicRate=15
BeaconPeriod=${beacon:-100}
DtimPeriod=${dtim:-1}
TxPower=${txpower:-100}
MaxUser=${maxuser:-20}
DisableOLBC=0
BGProtection=0
TxAntenna=
RxAntenna=
TxPreamble=1
RTSThreshold=${rtsthr:-2347}
FragThreshold=${fragthr:-2346}
TxBurst=0
PktAggregate=0
AutoProvisionEn=0
FreqDelta=0
TurboRate=0
WmmCapable=1
APAifsn=3;7;1;1
APCwmin=4;4;3;2
APCwmax=6;10;4;3
APTxop=0;0;94;47
APACM=0;0;0;0
BSSAifsn=3;7;2;2
BSSCwmin=4;4;3;2
BSSCwmax=10;10;4;3
BSSTxop=0;0;94;47
BSSACM=0;0;0;0
AckPolicy=0;0;0;0
APSDCapable=0
DLSCapable=0
NoForwarding=0
NoForwardingBTNBSSID=0
HideSSID=${hidessid:-0}
ShortSlot=1
AutoChannelSelect=${autochannel:-1}
IEEE8021X=0
IEEE80211H=0
CarrierDetect=0
ITxBfEn=0
PreAntSwitch=
PhyRateLimit=0
DebugFlags=0
ETxBfEnCond=0
ITxBfTimeout=0
ETxBfTimeout=0
ETxBfNoncompress=0
ETxBfIncapable=0
FineAGC=0
StreamMode=0
StreamModeMac0=
StreamModeMac1=
StreamModeMac2=
StreamModeMac3=
CSPeriod=6
RDRegion=
StationKeepAlive=0
DfsLowerLimit=0
DfsUpperLimit=0
DfsOutdoor=0
SymRoundFromCfg=0
BusyIdleFromCfg=0
DfsRssiHighFromCfg=0
DfsRssiLowFromCfg=0
DFSParamFromConfig=0
FCCParamCh0=
FCCParamCh1=
FCCParamCh2=
FCCParamCh3=
CEParamCh0=
CEParamCh1=
CEParamCh2=
CEParamCh3=
JAPParamCh0=
JAPParamCh1=
JAPParamCh2=
JAPParamCh3=
JAPW53ParamCh0=
JAPW53ParamCh1=
JAPW53ParamCh2=
JAPW53ParamCh3=
FixDfsLimit=0
LongPulseRadarTh=0
AvgRssiReq=0
DFS_R66=0
BlockCh=
GreenAP=0
PreAuth=0
AuthMode=${encryption:-OPEN}
EncrypType=${wpa_crypto:-NONE}
WapiPsk1=
WapiPsk2=
WapiPsk3=
WapiPsk4=
WapiPsk5=
WapiPsk6=
WapiPsk7=
WapiPsk8=
WapiPskType=0
Wapiifname=
WapiAsCertPath=
WapiUserCertPath=
WapiAsIpAddr=
WapiAsPort=
BssidNum=1
RekeyMethod=DISABLE
RekeyInterval=3600
PMKCachePeriod=10
MeshAutoLink=0
MeshAuthMode=
MeshEncrypType=
MeshDefaultkey=0
MeshWEPKEY=
MeshWPAKEY=
MeshId=
WPAPSK1=${key:-12345678}
WPAPSK2=
WPAPSK3=
WPAPSK4=
WPAPSK5=
WPAPSK6=
WPAPSK7=
WPAPSK8=
DefaultKeyID=1
Key1Type=0
Key1Str1=
Key1Str2=
Key1Str3=
Key1Str4=
Key1Str5=
Key1Str6=
Key1Str7=
Key1Str8=
Key2Type=0
Key2Str1=
Key2Str2=
Key2Str3=
Key2Str4=
Key2Str5=
Key2Str6=
Key2Str7=
Key2Str8=
Key3Type=0
Key3Str1=
Key3Str2=
Key3Str3=
Key3Str4=
Key3Str5=
Key3Str6=
Key3Str7=
Key3Str8=
Key4Type=0
Key4Str1=
Key4Str2=
Key4Str3=
Key4Str4=
Key4Str5=
Key4Str6=
Key4Str7=
Key4Str8=
HSCounter=0
HT_HTC=1
HT_RDG=1
HT_LinkAdapt=1
HT_OpMode=1
HT_MpduDensity=5
HT_EXTCHA=1
HT_BW=1
HT_AutoBA=1
HT_BADecline=0
HT_AMSDU=1
HT_BAWinSize=64
HT_GI=1
HT_STBC=1
HT_MCS=33
HT_TxStream=2
HT_RxStream=2
HT_PROTECT=1
HT_DisallowTKIP=1
HT_BSSCoexistence=0
GreenAP=0
WscConfMode=0
WscConfStatus=2
WCNTest=0
AccessPolicy0=0
AccessControlList0=
AccessPolicy1=0
AccessControlList1=
AccessPolicy2=0
AccessControlList2=
AccessPolicy3=0
AccessControlList3=
AccessPolicy4=0
AccessControlList4=
AccessPolicy5=0
AccessControlList5=
AccessPolicy6=0
AccessControlList6=
AccessPolicy7=0
AccessControlList7=
WdsEnable=0
WdsPhyMode=
WdsEncrypType=NONE
WdsList=
Wds0Key=
Wds1Key=
Wds2Key=
Wds3Key=
RADIUS_Server=
RADIUS_Port=1812
RADIUS_Key1=
RADIUS_Key2=
RADIUS_Key3=
RADIUS_Key4=
RADIUS_Key5=
RADIUS_Key6=
RADIUS_Key7=
RADIUS_Key8=
RADIUS_Acct_Server=
RADIUS_Acct_Port=1813
RADIUS_Acct_Key=
own_ip_addr=
Ethifname=
EAPifname=br-lan
PreAuthifname=br-lan
session_timeout_interval=0
idle_timeout_interval=0
WiFiTest=0
TGnWifiTest=0
ApCliEnable=${apcli:-0}
ApCliSsid=${apcli_ssid:-with01}
ApCliBssid=${apcli_bssid:-00:00:00:00:00:00}
ApCliAuthMode=${apcli_auth:-wpapsk}
ApCliEncrypType=${apcli_enc:-aes}
ApCliWPAPSK=${apcli_key:-dnlejtmwjdqhrltnf}
ApCliDefaultKeyID=0
ApCliKey1Type=0
ApCliKey1Str=
ApCliKey2Type=0
ApCliKey2Str=
ApCliKey3Type=0
ApCliKey3Str=
ApCliKey4Type=0
ApCliKey4Str=
RadioOn=1
SSID=
WPAPSK=
Key1Str=
Key2Str=
Key3Str=
Key4Str=
EOF
}

scan_rt3352() {
        local device="$1"
}

disable_rt3352() {
        local device="$1"
        config_get vifs "$device" vifs
        for vif in $vifs; do
                config_get ifname $vif ifname
		[ -f "/var/run/$ifname.pid" ] && kill -9 "$(cat /var/run/${ifname}.pid)" 2>/dev/null
		[ -f "/var/run/$ifname.pid" ] && rm -f "/var/run/${ifname}.pid" 2>/dev/null
                echo "ifconfig $ifname down"
                ifconfig $ifname down
        done
}

enable_rt3352() {
        local device="$1"
        prepare_config $device
        config_get vifs "$device" vifs
#        for vif in $vifs; do
#                ifconfig $ifname down
#				echo "whlee21 enable_rt3352 $ifname"
#        done
        config_get disabled "$device" disabled
        [ "$disabled" = "1" ] && return
        for vif in $vifs; do
                local ifname encryption key ssid
# echo "whlee21 aaaaaaaaaa vif=$vif"
                config_get ifname $vif ifname
                config_get encryption $vif encryption
                config_get key $vif key
                [ "$key" = "" -a "$vif" = "private" ] && {
                        logger "no key set serial"
                        key="AAAAAAAAAA"
                }
                config_get ssid $vif ssid
                config_get wpa_crypto $vif wpa_crypto
                echo "......." $ssid
                [ "$ssid" == "off" ] && echo ifconfig $ifname down
                [ "$ssid" == "off" ] || 
                {
                        ifconfig $ifname up
                        case "$encryption" in
                                wpa*|WPA*|Mixed|mixed)
                                        local enc
                                        case "$encryption" in
                                                WPA|WPA1|wpa|wpa1) enc=WPAPSK;;
                                                WPA2|wpa2) enc=WPA2PSK;;
                                                Mixed|mixed) enc=WPAPSKWPA2PSK;;
                                                *) enc=$encryption;;
                                        esac
                                        local crypto
                                        case "$wpa_crypto" in
                                                tkip|TKIP) crypto=TKIP;;
                                                aes|AES) crypto=AES;;
                                                tkip+aes|TKIP+AES) crypto=TKIPAES;;
                                                *) crypto=$wpa_crypto;;
                                        esac
                      #                  iwpriv $ifname set AuthMode=$enc
                      #                  iwpriv $ifname set EncrypType=$crypto
                      #                  iwpriv $ifname set IEEE8021X=0
                      #                  iwpriv $ifname set SSID=${ssid}
                      #                  iwpriv $ifname set WPAPSK=${key}
                      #                  iwpriv $ifname set DefaultKeyID=2
                      #                  iwpriv $ifname set SSID=${ssid}
                                        ;;
                                WEP|wep)
                      #                  iwpriv $ifname set AuthMode=SHARED
                      #                  iwpriv $ifname set EncrypType=WEP
                      #                  iwpriv $ifname set IEEE8021X=0
                      #                  iwpriv $ifname set Key1=${key}
                      #                  iwpriv $ifname set DefaultKeyID 1
                      #                  iwpriv $ifname set SSID=${ssid}
                                        ;;
                                none|open)
                                        ;;
                        esac
                        local net_cfg bridge
                        net_cfg="$(find_net_config "$vif")"
# echo "whlee21 bbbbbbbbbbbbbbbbb net_cfg=$net_cfg, vif=$vif"
                        [ -z "$net_cfg" ] || {
# for bridge ...
# bridge="$(bridge_interface "$net_cfg")"
# echo "whlee21 ddddddddddddddd vif=$vif"
# config_set "$vif" bridge "$bridge"
                                start_net "$ifname" "$net_cfg"
                        }
# echo "whlee21 cccccccccccccccc set_wifi_up ifname=$ifname"
                        set_wifi_up "$vif" "$ifname"
                }
        done
# echo "whlee21 enable_rt3352"
}

detect_rt3352() {
        cd /sys/module/
        [ -d rt2860v2_ap ] || return

        config_get ssid private ssid
        config_get encryption private encryption
        config_get key private key
        config_get wpa_crypto private wpa_crypto

        cat > /config/wireless_tether<<EOF

config wifi-device              rt3352
        option type             rt3352
        option channel          8
	    option apcli	        ${1:-0}
	    option apcli_ssid	    '${2:-enus}'
	    option apcli_bssid      00:00:00:00:00:00
	    option apcli_auth	    wpapsk
	    option apcli_enc	    aes
	    option apcli_key	    ${3:-12345678}

config wifi-iface               private
        option device           rt3352
        option ifname           ra0
        option network          lan
        option ssid             '${ssid:-rt3352}'
        option encryption       ${encryption:-open}
        option wpa_crypto       ${wpa_crypto:-none}
        option key              ${key:-12345678}
        option beacon           100
        option dtim             1
        option txburst          1
        option autochannel      1
        option mode             9
        option hidessid         0
        option rtsthr           2347
        option fragthr          2346
        option maxuser          20
        option txpower          100


config wifi-iface               uplink
	    option device	        rt3352
	    option ifname	        apcli0
	    option mode		        sta
EOF
}
